
#ifdef _WIN32
#include <windows.h>
#endif

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string.h>
#include "txtfile.h"

using namespace std;

void TextPriv(int level, va_list *args, char *text,
	bool msgbox = false, bool console = false, bool file = false);
	
static char *File_Name;
static fstream File;
static bool pconsole;
static bool pfile;
static bool pmsgbox;
static int Level;

void FILE_Open(char *file_name, bool console, bool file, bool msgbox)
{
	File_Name = file_name;
	Level = TXTFILE_INFO;
	File.open(File_Name, ios::out | ios::trunc);
	if (File.fail() || File.bad()) Level = TXTFILE_NONE;
	pconsole = console;
	pfile = file;
	pmsgbox = msgbox;
}

void FILE_Close()
{
	File.close();
}

void FILE_Level(int level)
{
	Level = level;
}

void FILE_SetFlags(bool console, bool file, bool msgbox)
{
	pconsole = console;
	pfile = file;
	pmsgbox = msgbox;
}

void FILE_Flush(void)
{
	File.flush();
}

void FILE_Text(int level, char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(level, &args, text);
	va_end(args);
	return;
}

void FILE_Text(int level, bool msgbox, bool console,
				   bool file, char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(level, &args, text, msgbox, console, file);
	va_end(args);
	return;
}

void FILE_TextI(char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(TXTFILE_INFO, &args, text);
	va_end(args);
	return;
}

void FILE_TextV(char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(TXTFILE_VERBOSE, &args, text);
	va_end(args);
	return;
}

void FILE_TextE(char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(TXTFILE_EXTRA, &args, text);
	va_end(args);
	return;
}

void FILE_TextD(char *text, ...)
{
	va_list args;
	va_start(args, text);
	TextPriv(TXTFILE_EXTRADEBUG, &args, text);
	va_end(args);
	return;
}
	
void TextPriv(int level, va_list *args, char *text,
					   bool msgbox, bool console, bool file)
{
#if FILE_ONOFF == FILE_ON
	switch (Level)
	{
	case TXTFILE_NONE:
		return;
	case TXTFILE_INFO:
		if (level > TXTFILE_INFO) return;
		break;
	case TXTFILE_VERBOSE:
		if (level > TXTFILE_VERBOSE) return;
		break;
	case TXTFILE_EXTRA:
		if (level > TXTFILE_EXTRA) return;
		break;
	case TXTFILE_EXTRADEBUG:
		if (level > TXTFILE_EXTRADEBUG) return;
		break;
	};
	
//	int len = vsprintf(NULL, text, *args);
	char *buffer = new char[1024];
	vsprintf(buffer, text, *args);
	
	if (pfile || file)
	{
		File.write(buffer, strlen(buffer));
		File.flush();
	}

	if (pconsole || console)
	{
		printf("%s", buffer);
	}

#ifdef _WIN32
	if (pmsgbox || msgbox)
	{
		MessageBox(NULL, buffer, "NOTICE", MB_OK | MB_ICONEXCLAMATION);
	}
#endif

	delete[] buffer;
#endif
	return;
}
