/*
	Blokus SDL
		blcommand.h

	This file defines class COMMAND.

	Copyright (C) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BLCOMMAND_H
#define BLCOMMAND_H

//**********************************************************
//* CLASS DEFINITIONS

//**********************************************************
/**
	Class COMMAND.
*/
class COMMAND
{
public:
	/* Constructors and destructor. */
	COMMAND(char *command, void (*)(int), int value = 0);
	COMMAND(char *command, void (*)(void));
	COMMAND(char *command, int *var, int value);
	~COMMAND();

	/* Public methods. */
	COMMAND *find(char *command);
	
	/* Public methods. */
	COMMAND *find_and_exec(char *command, int value = 0);

	/* Execute command function. */
	void exec(void);

	/* Execute command function. */
	void execv(int value);

	/* Add new int command to list. */
	void add(char *command, void (*)(int), int value = 0);

	/* Add new void command to list. */
	void add(char *command, void (*)(void));

	/* Add new void command to list. */
	void add(char *command, int *var, int value);

private:
	/* Private variables. */
	/** For executing function which need input. */
	void (*execvalue)(int);

	/** For executing pure void function. */
	void (*execvoid)(void);

	/** For variable saving some variables poiner. */
	int *var;

	/** Pointer to next command. */
	COMMAND *next;
	
	/** Value for executing the command. */
	int value;

	/** Command string. */
	char *cmd;
};

#endif


