/*
	Blokus SDL
		blgbuttons.cpp

	This file declares some button handling in game
	under class APP.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include "blapp.h"
#include "blvideo.h"

//**********************************************************
//* METHODS

//**********************************************************
/*
	class APP.
*/

//**********************************************************
/**
	Handle and draw buttons before starting the game.
*/
void APP::game_buttons(int selected_item)
{
	if (g.game_run())
	{
		game_buttons_in(selected_item);
	}
	else
	{
		game_buttons_before(selected_item);
	}
}

//**********************************************************
/**
	Handle and draw buttons before starting the game.
*/
void APP::game_buttons_before(int selected_item)
{
	for (int i = 0; i < bGN; i++)
	{
/*		SDL_Rect r;
		
		r.w = bgam.B.w[i];
		r.h = bgam.B.h[i];
		r.x = bgam.B.x1[i];
		r.y = bgam.B.y1[i];

		SDL_BlitSurface(BG.srf, &r, vscreen, &r);*/

		if (i == bGchat)
		{
		}
		else if (i == bGstore)
		{
		}
		else if (i == bGboard)
		{
		}
		else
		{
			char *str = NULL;
			NET_CONNECTION_PACKET *pp = NULL;

			switch (i)
			{
			default:
			case bGskip:
				if (!NET_Host())
				{
					continue;
				}
				str = "Start";
				break;
			case bGsettings:
				str = "Settings";
				break;
			case bGexit:
				str = "Exit";
				break;
			case bGplayer1:
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_BLUE));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer2:
				if (g.get_nof_players() < 2)
				{
					str = NULL;
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_GREEN));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer3:
				if (g.get_nof_players() < 3)
				{
					str = NULL;
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_RED));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer4:
				if (g.get_nof_players() < 4)
				{
					str = NULL;
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_YELLOW));
				if (pp)
				{
					str = pp->name;
				}
				break;
			}

			if (str == NULL);
			else if (i == selected_item)
			{
				VID_RenderTTF2Srf(bgam.B.x1[i], bgam.B.y1[i],
								  str, &cOther,
								  vscreen, dFont, false, &cbOther);
			}
			else
			{
				VID_RenderTTF2Srf(bgam.B.x1[i], bgam.B.y1[i],
								  str, &cOther,
								  vscreen, dFont);
			}

			SDL_Color *clr;
			str = NULL;
			int pts = 0;

			switch (i)
			{
			case bGplayer1:
				clr = &Blue;
				str = "blue";
				pts = g.get_points(COLOR_BLUE);
				break;
			case bGplayer2:
				if (g.get_nof_players() < 2)
				{
					str = NULL;
					break;
				}
				clr = &Green;
				str = "green";
				pts = g.get_points(COLOR_GREEN);
				break;
			case bGplayer3:
				if (g.get_nof_players() < 3)
				{
					str = NULL;
					break;
				}
				clr = &Red;
				str = "red";
				pts = g.get_points(COLOR_RED);
				break;
			case bGplayer4:
				if (g.get_nof_players() < 4)
				{
					str = NULL;
					break;
				}
				clr = &Yellow;
				str = "yellow";
				pts = g.get_points(COLOR_YELLOW);
				break;
			}
			
			if (str)
			{
				VID_RenderTTF2Srf(bgam.B.x1[i] + 90, bgam.B.y1[i],
						          str, clr,
						          vscreen, dFont);

				VID_RenderTTF2SrfSolid(bgam.B.x1[i] + 160,
					                   bgam.B.y1[i], &cOther,
									   vscreen, dFont,
									   "%i", pts);
			}

			if (pp)
			{
				NET_Free(pp);
				pp = NULL;
			}
		}
	}
}

//**********************************************************
/**
	Handle and draw buttons after starting the game.
*/
void APP::game_buttons_in(int selected_item)
{
	for (int i = 0; i < bGN; i++)
	{
/*		SDL_Rect r;
		
		r.w = bgam.B.w[i];
		r.h = bgam.B.h[i];
		r.x = bgam.B.x1[i];
		r.y = bgam.B.y1[i];

		SDL_BlitSurface(BG.srf, &r, vscreen, &r);*/

		if (i == bGchat)
		{
			//*
		}
		else if (i == bGstore)
		{
			//*
		}
		else if (i == bGboard)
		{
			//*
		}
		else
		{
			char *str = NULL;
			SDL_Color *color = &cOther;
			NET_CONNECTION_PACKET *pp = NULL;

			switch (i)
			{
			default:
			case bGskip:
				str = "Give up";
				break;
			case bGsettings:
				str = "Settings";
				break;
			case bGexit:
				str = "Exit";
				break;
			case bGplayer1:
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_BLUE));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer2:
				if (g.get_nof_players() < 2)
				{
					str = "#green";
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_GREEN));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer3:
				if (g.get_nof_players() < 3)
				{
					str = "#red";
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_RED));
				if (pp)
				{
					str = pp->name;
				}
				break;
			case bGplayer4:
				if (g.get_nof_players() < 4)
				{
					str = "#yellow";
					break;
				}
				pp = NET_GetConnectionInfo(g.get_color_id(COLOR_YELLOW));
				if (pp)
				{
					str = pp->name;
				}
				if (g.get_current_color() == COLOR_YELLOW)
				{
					color = &cTurn;
				}
				break;
			}

			if (g.get_nof_players() == 1)
			{
				switch (i)
				{
				case bGplayer1:
					color = &cTurn;
					break;
				}
			}
			else if (g.get_nof_players() == 2)
			{
				switch (i)
				{
				case bGplayer1:
					if (g.get_current_color() == COLOR_BLUE ||
						g.get_current_color() == COLOR_RED)
					{
						color = &cTurn;
					}
					break;
				case bGplayer2:
					if (g.get_current_color() == COLOR_GREEN ||
						g.get_current_color() == COLOR_YELLOW)
					{
						color = &cTurn;
					}
					break;
				}
			}
			else if (g.get_nof_players() == 3)
			{
				switch (i)
				{
				case bGplayer1:
					if (g.get_current_color() == COLOR_BLUE ||
						(g.get_current_color() == COLOR_YELLOW &&
						(g.get_round() % 3) == 0))
					{
						color = &cTurn;
					}
					break;
				case bGplayer2:
					if (g.get_current_color() == COLOR_GREEN ||
						(g.get_current_color() == COLOR_YELLOW &&
						((g.get_round() + 2) % 3) == 0))
					{
						color = &cTurn;
					}
					break;
				case bGplayer3:
					if (g.get_current_color() == COLOR_RED ||
						(g.get_current_color() == COLOR_YELLOW &&
						((g.get_round() + 1) % 3) == 0))
					{
						color = &cTurn;
					}
					break;
				}
			}

			if (str == NULL);
			else if (i == selected_item)
			{
				VID_RenderTTF2Srf(bgam.B.x1[i], bgam.B.y1[i],
								  str, color,
								  vscreen, dFont, false, &cbOther);
			}
			else
			{
				VID_RenderTTF2Srf(bgam.B.x1[i], bgam.B.y1[i],
								  str, color,
								  vscreen, dFont);
			}

			SDL_Color *clr;
			str = NULL;
			int pts = 0;

			switch (i)
			{
			case bGplayer1:
				clr = &Blue;
				str = "blue";
				pts = g.get_points(COLOR_BLUE);
				break;
			case bGplayer2:
				if (g.get_nof_players() < 2)
				{
					str = "foo";
					clr = &cOther;
				}
				else
				{
					str = "green";
					clr = &Green;
				}
				pts = g.get_points(COLOR_GREEN);
				break;
			case bGplayer3:
				if (g.get_nof_players() < 3)
				{
					str = "foo";
					clr = &cOther;
				}
				else
				{
					str = "red";
					clr = &Red;
				}
				pts = g.get_points(COLOR_RED);
				break;
			case bGplayer4:
				if (g.get_nof_players() < 4)
				{
					str = "foo";
					clr = &cOther;
				}
				else
				{
					str = "yellow";
					clr = &Yellow;
				}
				pts = g.get_points(COLOR_YELLOW);
				break;
			}
			
			if (str)
			{
				VID_RenderTTF2Srf(bgam.B.x1[i] + 90, bgam.B.y1[i],
						          str, clr,
						          vscreen, dFont);

				VID_RenderTTF2SrfSolid(bgam.B.x1[i] + 160,
					                   bgam.B.y1[i], &cOther,
									   vscreen, dFont,
									   "%i", pts);
			}
			
			if (pp)
			{
				NET_Free(pp);
				pp = NULL;
			}
		}
	}
}

