/*
	Blokus SDL
		blgame.cpp

	This file declares command methods for class GAME chat.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include "blgame.h"

//**********************************************************
//* FUNCTION DEFINITIONS
void cmd_open(void);
void cmd_close(void);
void cmd_kick(int);

//**********************************************************
//* METHODS

//**********************************************************
/*
	class GAME.
*/

//**********************************************************
/**
	Create chat command list.
*/
void GAME::cmds_create(void)
{
	/* Open. */
	box.add_command("open", cmd_open);

	/* Close. */
	box.add_command("close", cmd_close);

	/* Kick. */
	box.add_command("kick", cmd_kick);
}

//**********************************************************
//* FUNCTIONS

//**********************************************************
/**
	Open the game.
*/
void cmd_open(void)
{
	/* Do. */
	NET_SetClosed(false);
}

//**********************************************************
/**
	Close the game.
*/
void cmd_close(void)
{
	/* Do. */
	NET_SetClosed(true);
}

//**********************************************************
/**
	Kick user.
*/
void cmd_kick(int u)
{
	/* Variables. */
	NET_CONNECTION_PACKET *p;
	char *user;

	/* Check input. */
	if (!u)
	{
		return;
	}
	
	/* Check len. */
	if (strlen((char *)u) < 1)
	{
		return;
	}

	/* Set pointer. */
	user = (char *)u;

	/* Remove spaces. */
	for ( ; *user == ' '; user++);

	/* Get user ID. */
	p = NET_GetConnectionInfo(user);

	/* Kick. */
	if (p)
	{
		NET_Kick(p->id);
	}
}

//**********************************************************
/**
	Send private message.
*/
/*void cmd_send_msg(char *cmd)
{
	if (strlen(cmd) < 5)
	{
		return;
	}

	int n = 3;

	while (cmd[n] == ' ')
	{
		if (cmd[n] == '\0')
		{
			return;
		}

		n++;
	}

	int h = n;

	while (cmd[n] != ' ')
	{
		if (cmd[n] == '\0')
		{
			AddLine("You must write your message after nick");
			return;
		}

		n++;
	}

	cmd[n] = '\0';

	NET_CONNECTION_PACKET *p = NET_GetConnectionInfo(cmd + h);
	
	if (!p)
	{
		AddLine("Player not found");
		return;
	}

	cmd[n] = '/';

	NET_SendString(cmd + n, p->id);

	NET_Free(p);
}*/
