/*
	Blokus SDL
		blgend.cpp

	This file declares functions for game end
	and game quit.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include "blgame.h"
#include "blexceptions.h"

//**********************************************************
//* METHODS

//**********************************************************
/*
	class GAME.
*/

//**********************************************************
/**
	When game comes to end...
	Count points for players and display them.
*/
void GAME::ends(void)
{
	/* Play sound. */
//	SND_Play(snd_gameover);

	/* Display points. */
	char string[256];

	box.add_line("***** End of game");

	if (nofplayers == 1)
	{
		sprintf(string, "Points for blue: %i", points[COLOR_BLUE]);
		box.add_line(string);
		sprintf(string, "Points for green: %i", points[COLOR_GREEN]);
		box.add_line(string);
		sprintf(string, "Points for red: %i", points[COLOR_RED]);
		box.add_line(string);
		sprintf(string, "Points for yellow: %i", points[COLOR_YELLOW]);
		box.add_line(string);
	}
	else if (nofplayers == 2)
	{
		NET_CONNECTION_PACKET *pp;

		pp = NET_GetConnectionInfo(color_ids[COLOR_BLUE]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_BLUE] + points[COLOR_RED]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_GREEN]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_GREEN] + points[COLOR_YELLOW]);
		box.add_line(string);
		NET_Free(pp);
	}
	else if (nofplayers == 3)
	{
		NET_CONNECTION_PACKET *pp;

		pp = NET_GetConnectionInfo(color_ids[COLOR_BLUE]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_BLUE]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_GREEN]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_GREEN]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_RED]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_RED]);
		box.add_line(string);
		NET_Free(pp);
	}
	else if (nofplayers == 4)
	{
		NET_CONNECTION_PACKET *pp;

		pp = NET_GetConnectionInfo(color_ids[COLOR_BLUE]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_BLUE]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_GREEN]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_GREEN]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_RED]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_RED]);
		box.add_line(string);
		NET_Free(pp);

		pp = NET_GetConnectionInfo(color_ids[COLOR_YELLOW]);
		sprintf(string, "Points for %s: %i",
			    pp->name, points[COLOR_YELLOW]);
		box.add_line(string);
		NET_Free(pp);
	}

	end = true;
	game_running = false;

	if (NET_Host())
	{
		NET_SetClosed(false);
	}

	/* Return. */
	return;
}

//**********************************************************
/**
	This function is called, when game-mode is exited.
	Here is released everything, that is reserved mostly
	in Init().
*/
void GAME::quit(void)
{
	/* Release image of bricks. */
	brick_image.~DPIC();

	/* Return. */
	return;
}

