/*
	Blokus SDL
		blstore.h

	This file defines class GRID.

	Copyright (C) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BLGRID_H
#define BLGRID_H

//**********************************************************
//* INCLUDES
#include "blmybricks.h"

//**********************************************************
//* CLASS DEFINITIONS

//**********************************************************
/**
	Class GRID.
*/
class GRID
{
public:
	/* Public methods. */
	/* Contructor and destructor. */
	GRID(int x, int y, int w, int h, int one_x, int one_y);
	~GRID();
	
	/* This clears area to given value. */
	void clear(unsigned char value = 0xff);

	/* Set bricks to store area. */
	void set(int selected_brick,
		     int selected_color,
		     MY_BRICKS *my_bricks);

	/* Draw store area to screen. */
	void draw(int tile_set,
		      DPIC *brick_image,
		      SDL_Surface *srf);

	/* Get value of store in wanted coordinates. */
	unsigned char get_value(int x, int y);

	/* Set value of store in wanted coordinates. */
	void set_value(unsigned char value, int x, int y);

	/* Return pointer to grid. */
	unsigned char *get_area_pointer(void);

private:
	/* Private variables. */
	/** Area-pointer. */
	unsigned char *area;

	/** x-coordinate. */
	int coord_x;

	/** y-coordinate. */
	int coord_y;

	/** Width. */
	int width;

	/** Height. */
	int height;

	/** One item x-size in screen. */
	int one_x;

	/** One item y-size in screen. */
	int one_y;
};

#endif

