/*
	Blokus SDL
		blmisc.h

	Defines some misc functions.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include "dpic.h"

//**********************************************************
//* DEFINES

/*
	Small value like 3 Should be enough.
*/
#define N_OF_THREADS 3

/* Define transparency color for transparent blitting. */
#define TRANSPARENT_R 8
#define TRANSPARENT_G 8
#define TRANSPARENT_B 248

/* Some struct and class definitions. */
struct TTEXTDATA
{
	int Tid;
	DPIC *Tsrf;
	unsigned short Tgid;
	char *Tdtf;
};

/* Class for threads. */
class THREAD
{
public:
	THREAD()
	{
		Pid = NULL;
		Run = false;

		Data = NULL;
	}

	SDL_Thread *Pid;
	bool Run;
	void *Data;
};

//**********************************************************
//* FUNCTION DEFINITIONS
int LoadDMF(DPIC *srf, unsigned short id, char *dtf,
	        bool setcolorkey = false,
			Uint8 alpha = SDL_ALPHA_OPAQUE,
			SDL_PixelFormat *fmt = NULL);
int LoadTexture(DPIC *srf, unsigned short Gid, char *dtf);
void WaitLoadTexture(unsigned int id);
void ScreenShot(void);

