/*
	Blokus SDL
		blnick.cpp

	This file includes function Nick() for class APP

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include "blapp.h"
#include "blnick.h"
#include "blvideo.h"

//**********************************************************
//* METHODS

//**********************************************************
/*
	class APP.
*/

//**********************************************************
/**
	Run the nick selection menu.
*/
void APP::nick(int button)
{
	int i;
	SDL_Rect r;

	if (mouse_bt & SDL_BUTTON(3))
	{
		if (strlen(st.Nicks[0]) > 0)
		{
			string_get = false;
		}
	}

	if (mouse_bt & SDL_BUTTON(1))
	{
		if (strlen(st.Nicks[0]) > 0)
		{
			if (strlen(input) > 0 && string_get
				&& input[0] != ' ')
			{
				for (i = 0; i < MAX_NICKS; i++)
				{
					if (strncmp(st.Nicks[i],
						input, MAX_NICKLEN) ==0)
					{
						break;
					}
				}

				if (i == MAX_NICKS)
				{
					strncpy(st.Nicks[st.current_nick],
						input, MAX_NICKLEN);
				}
			}

			string_get = false;
		}
	}

	while (button > -1)
	{
		if (bnic.state[button] > 1 && bnic.state[button] != 8)
		{
			bnic.state[button] = 0;
			break;
		}

		switch (button)
		{
		case bNexit:
			Mode = rMode;
			rMode = MEXIT;
			break;

		case bNnew:
			for (i = 0; i < MAX_NICKS; i++)
			{
				if (strlen(st.Nicks[i]) < 1)
				{
					memset(input, 0, MAX_INPUT);
					st.current_nick = i;
					input_x = bnic.B.x1[st.current_nick + bNN];
					input_y = bnic.B.y1[st.current_nick + bNN];
					string_get = true;
					break;
				}
			}

			break;

		case bNdelete:
			if (st.current_nick != 0 || strlen(st.Nicks[1]) > 0)
			{
				for (i = st.current_nick; i < (MAX_NICKS - 1); i++)
				{
					strcpy((char *)st.Nicks[i], st.Nicks[i + 1]);
				}

				st.Nicks[i][0] = '\0';
				
				while (strlen(st.Nicks[st.current_nick]) < 1)
				{
					st.current_nick--;

					if (st.current_nick < 1)
					{
						st.current_nick = 0;
					}
				}
			}

			break;

		case bNselect:
			if (strlen(st.Nicks[st.current_nick]) > 0)
			{
				Mode = MJOIN;
			}
			
			break;

		default:
			for (i = bNN; i < (bNN + MAX_NICKS); i++)
			{
				if (bnic.state[i] == 1)
				{
					if (strlen(st.Nicks[i - bNN]) > 0)
					{
						st.current_nick = i - bNN;
					}
				}
				else if (bnic.state[i] == 8)
				{
					if (strlen(st.Nicks[i - bNN]) > 0)
					{
						st.current_nick = i - bNN;
						Mode = MJOIN;
					}
				}
			}
			
			break;
		}
	
		bnic.state[button] = 0;

		break;
	}

	for (i = 0; i < bNN; i++)
	{
		if (bnic.B.pushed[i])
		{
			VID_RenderTTF2Srf(bnic.B.x1[i], bnic.B.y1[i],
				bnic.B.name[i], &MLText, vscreen, MFont, true, &MDText);
		}
		else
		{
			r.w = bnic.B.w[i];
			r.h = bnic.B.h[i];
			r.x = bnic.B.x1[i];
			r.y = bnic.B.y1[i];
			SDL_BlitSurface(BG.srf, &r, vscreen, &r);
			VID_RenderTTF2Srf(bnic.B.x1[i], bnic.B.y1[i],
				bnic.B.name[i], &MDText, vscreen, MFont);
		}
	}

	for (i = bNN; i < (bNN + MAX_NICKS); i++)
	{
		if ((i - bNN) == st.current_nick)
		{
			if (!string_get)
			{
				r.w = bnic.B.w[i] + 32;
				r.h = bnic.B.h[i];
				r.x = bnic.B.x1[i];
				r.y = bnic.B.y1[i];
				SDL_BlitSurface(BG.srf, &r, vscreen, &r);
				VID_RenderTTF2Srf(bnic.B.x1[i], bnic.B.y1[i],
					st.Nicks[i - bNN], &MLText, vscreen, dFont);
			}
		}
		else
		{
			r.w = bnic.B.w[i] + 32;
			r.h = bnic.B.h[i];
			r.x = bnic.B.x1[i];
			r.y = bnic.B.y1[i];
			SDL_BlitSurface(BG.srf, &r, vscreen, &r);
			VID_RenderTTF2Srf(bnic.B.x1[i], bnic.B.y1[i],
				st.Nicks[i - bNN], &MMText, vscreen, dFont);
		}
	}

	VID_RenderTTF2Srf(288, 38, "Nick names:", &White, vscreen, dFont);

	return;
}

//**********************************************************
/**
	Handle keypresses in nick-menu.
*/
void APP::nick_keys(SDL_keysym *keysym, bool ud)
{
	/* Handle keypresses. */
	if (ud)
	{
//		switch (keysym->sym)
		{
		}
	}
	/* Handle key releases. */
	else
	{
		switch (keysym->sym)
		{
		case SDLK_ESCAPE:
			if (!string_get)
			{
				bnic.state[bNexit] = -1;
			}
			else if (strlen(st.Nicks[0]) > 0)
			{
				if (strlen(st.Nicks[st.current_nick]) > 0)
				{
					string_get = false;
				}
				else
				{
					st.current_nick = 0;
					string_get = false;
				}
			}

			break;

		case SDLK_RETURN:
			if (!string_get)
			{
				bnic.state[bNselect] = -1;
			}
			else if (strlen(input) > 0 && input[0] != ' ')
			{
				int i;
				for (i = 0; i < MAX_NICKS; i++)
				{
					if (strncmp(st.Nicks[i],
						input, MAX_NICKLEN) ==0)
					{
						break;
					}
				}

				if (i == MAX_NICKS)
				{
					strncpy(st.Nicks[st.current_nick],
						input, MAX_NICKLEN);
				}

				string_get = false;
			}

			break;
		}
	}

	/* Return. */
	return;
}

