/*
	Blokus SDL
		blst.c

	This file includes setting loading and saving functions.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//**********************************************************
//* INCLUDES
#include <cstdio>

#include "blst.h"

//**********************************************************
//* FUNCTIONS

//**********************************************************
/**
	Funtion for saving settings.
*/
EVALUE SaveSettings(char *file,
					char *st, int st_size,
					char *gst, int gst_size)
{
	/* Open the file stream. */
	FILE *f = fopen(file, "wb");

	/* Check errors. */
	if (!f)
	{
		return (E_FILEFAIL);
	}

	/* Write data to file. */
	fwrite(st, st_size, 1, f);
	fwrite(gst, gst_size, 1, f);

	/* Close stream. */
	fclose(f);

	/* Return. */
	return (A_OK);
}

//**********************************************************
/**
	Funtion for reading settings.
*/
EVALUE ReadSettings(char *file,
					char *st, int st_size,
					char *gst, int gst_size)
{
	/* Open the file stream. */
	FILE *f = fopen(file, "rb");

	/* Check for errors. */
	if (!f)
	{
		/* If failed, then try to create new settings file. */
		return (SaveSettings(file, st, st_size, gst, gst_size));
	}

	/* Read data. */
	fread(st, st_size, 1, f);
	fread(gst, gst_size, 1, f);

	/* Close stream. */
	fclose(f);

	/* Return. */
	return (A_OK);
}

