/*
	Blokus SDL
		blstruct.h

	This file includes some struct definitions.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BLSTRUCT_H
#define BLSTRUCT_H

//**********************************************************
//* Includes
#include "blkeymap.h"

//**********************************************************
//* Defines, structures, classes,...

//* Maximum amount of nicks shown in nick selection menu.
//* (and amount of nicks stored).
#define MAX_NICKS 10
#define MAX_NICKLEN 13
#define MAX_PLAYERS 4

//* Maximum amount of games displayed in join menu.
#define MAX_GAMES 8

//* Class for game settings.
class GAME_SETTINGS
{
public:
	GAME_SETTINGS()
	{
		ai_level = 1;
		n_opponents = 0;
		tile_set = 0;
	}

	int ai_level;
	int n_opponents;
	int tile_set;

	KEYMAP key;
};

//* Class for application settings.
class SETTINGS
{
public:
	SETTINGS()
	{
		w = 640;
		h = 480;
		bpp = 1;
		fullscreen = 0;
		
		volume = 25;
		snd_enabled = 1;

		rseed = SDL_GetTicks();

		for (int i = 0; i < MAX_NICKS; i++)
		{
			Nicks[i][0] = '\0';
		}

		current_nick = 0;
	};

	int w;
	int h;
	int bpp;
	int fullscreen;

	int volume;
	bool snd_enabled;

	unsigned int rseed;
	
	int current_nick;

	char Nicks[MAX_NICKS][MAX_NICKLEN + 1];
};

#endif
