/*
	Blokus SDL
		nxtables.h

	This file defines some tables.

	Copyright (c) 2003-2004 Antti Partanen


	This file is part of Blokus SDL.

	Blokus SDL is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Blokus SDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Blokus SDL; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BLTABLES_H
#define BLTABLES_H

#include "blbuttons.h"
#include "blmenu.h"
#include "blnick.h"
#include "bljoin.h"
#include "blgame.h"
#include "blsettings.h"

//* static array for settings info
static char *SETTINGS_INFO[] =
{
	//* Video
	"Select fullscreen: <yes, no>", NULL, NULL, NULL,
	"Select color depth: <8, 16, 24, 32>", NULL, NULL, NULL,

	//* Audio
	"Enable sounds: <yes, no>", NULL, NULL, NULL,
	"Adjust volume: <0 - 100>", NULL, NULL, NULL,
	
	//* Game settings
	"AI level:",
	" Gump - Stupid",
	" You  - Normal",
	" Duge - Intelligent",

	"Number of AI players in game: <0 - 3>", NULL, NULL, NULL,

	"Tile set:", " Rock - nice rock tile set.",
	" Wood - woody and bright tile set.", NULL,

	//* Keyboard configuration
	"Rotate left", NULL, NULL, NULL,
	"Rotate right", NULL, NULL, NULL,
	"Flip horizontaly", NULL, NULL, NULL,
	"Flip vertically", NULL, NULL, NULL,
	"Drops brick at once down to bottom", NULL, NULL, NULL,
	"Pauses the game", NULL, NULL, NULL
};

//* static defines for buttons
static BT bmenuT[] =
{
	{ BM_X, BM_Y + BM_YADD * 0, BM_W,
		BM_H, bMplay, 0, 0, "PLAY", NULL, NULL }, //* Play
	{ BM_X, BM_Y + BM_YADD * 1, BM_W,
		BM_H, bMsettings, 0, 0,
		"SETTINGS", NULL, NULL }, //* Settings
	{ BM_X, BM_Y + BM_YADD * 3, BM_W,
		BM_H, bMexit, 0, 0, "EXIT", NULL, NULL}, //* Exit
};

static BT bsetT[] =
{
	//* Video settings
	{ BS_X, BS_Y + BS_YADD * 0, BS_W,
		BS_H, bSfullscreen, 0, BT_FLAG_START, "Fullscreen:",
		"Video", "no", "yes", NULL }, //* Fullscreen
	{ BS_X, BS_Y + BS_YADD * 1, BS_W,
		BS_H, bSbpp, 0, BT_FLAG_MIDDLE, "BPP:",
		NULL, "8", "16", "24", "32", NULL }, //* Bpp

	//* Audio settings
	{ BS_X, BS_Y + BS_YADD * 3, BS_W,
		BS_H, bSsen, 1, BT_FLAG_START, "Enable sounds & music:",
		"Audio", "no", "yes", NULL }, //* Volume
	{ BS_X, BS_Y + BS_YADD * 4, BS_W,
		BS_H, bSvol, 50, BT_FLAG_MIDDLE, "Volume:",
		NULL, "$0,100,1,100,155", NULL }, //* Volume

	//* Game settings
	{ BS_X, BS_Y + BS_YADD * 6, BS_W,
		BS_H, bSai, 1, BT_FLAG_START, "AI level:",
		"Game settings",
		"Gump", "You", "Duge", NULL }, //* AI level
	{ BS_X, BS_Y + BS_YADD * 7, BS_W,
		BS_H, bSno, 0, BT_FLAG_MIDDLE, "Number of AI opponents:",
		NULL, "0", "1", "2", "3",
		NULL }, //* Number of AIs
	{ BS_X, BS_Y + BS_YADD * 8, BS_W,
		BS_H, bSts, 0, BT_FLAG_END, "Tile set:",
		NULL, "Rock", "Wood", NULL }, //* Tile set

	//* Other buttons
	{ 80, 400, 0,
		0, bSexit, 0, BT_FLAG_NONE, "DONE", NULL, NULL }, //* Exit
	{ 80, 430, 0,
		0, bScancel, 0, BT_FLAG_NONE, "CANCEL", NULL, NULL }, //* Cancel

	//* Keyboard setup
	{ BS_X + BS_XADD, BS_Y + BS_YADD * 0, BS_W,
		BS_H, bSkl, 0, BT_FLAG_START,
		"Rotate left:", "Keyboard setup", NULL , NULL }, //* Rotate left
	{ BS_X + BS_XADD, BS_Y + BS_YADD * 1, BS_W,
		BS_H, bSkr, 0, BT_FLAG_MIDDLE,
		"Rotate right:", NULL, NULL, NULL }, //* Rotate right
	{ BS_X + BS_XADD, BS_Y + BS_YADD * 2, BS_W,
		BS_H, bSkh, 0, BT_FLAG_MIDDLE,
		"Horizontal flip:", NULL, NULL, NULL }, //* Flip horiz
	{ BS_X + BS_XADD, BS_Y + BS_YADD * 3, BS_W,
		BS_H, bSkv, 0, BT_FLAG_MIDDLE,
		"Vertical flip:", NULL, NULL, NULL }, //* Flip vert
};

static BT bnicT[] =
{
	{ BN_EXIT_X, BN_EXIT_Y, BN_W,
		BN_H, 0, 0, 0, "CANCEL", NULL, NULL }, //* Cancel
	{ BN_SELECT_X, BN_SELECT_Y, BN_W,
		BN_H, 0, 0, 0, "SELECT", NULL, NULL }, //* Select
	{ BN_NEW_X, BN_NEW_Y, BN_W,
		BN_H, 0, 0, 0, "NEW", NULL, NULL }, //* New
	{ BN_DELETE_X, BN_DELETE_Y, BN_W,
		BN_H, 0, 0, 0, "DELETE", NULL, NULL }, //* Delete
};

static BT bcreT[] =
{
	{ BC_CANCEL_X, BC_CANCEL_Y, BC_W,
		BC_H, bCcancel, 0, 0, "CANCEL", NULL, NULL }, //* Cancel
	{ BC_JOIN_X, BC_JOIN_Y, BC_W,
		BC_H, bCjoin, 0, 0, "JOIN", NULL }, //* Join
	{ BC_CREATE_X, BC_CREATE_Y, BC_W,
		BC_H, bCcreate, 0, 0, "CREATE", NULL, NULL }, //* Create
	{ BC_STATE_X, BC_STATE_Y, BC_W,
		BC_H, bCstate, 0, 0, "STATE", NULL, NULL }, //* State
};

static BT bgamT[] =
{
	//* Usage
	{ BG_SX, BG_SY, BG_UW, BG_UH,
		bGskip, 0, 0, "Skip", NULL, NULL }, //* Skip
	{ BG_CX, BG_CY, BG_UW, BG_UH,
		bGsettings, 0, 0, "Settings", NULL, NULL }, //* Settings
	{ BG_EX, BG_EY, BG_UW, BG_UH,
		bGexit, 0, 0, "Exit", NULL, NULL }, //* Exit
	//* Store are
	{ STORE_X, STORE_Y - 8, STORE_XSIZE * BRICK_XSIZE,
		STORE_YSIZE * BRICK_YSIZE + 8,
		bGstore, 0, 0, "Store", NULL, NULL }, //* Store area
	{ 0, 0, BOARD_XSIZE * BRICK_XSIZE + 32,
		BOARD_YSIZE * BRICK_YSIZE + 24,
		bGboard, 0, 0, "Board", NULL, NULL }, //* Store area
	//* Players
	{ BG_PLAYERX, BG_PLAYERY + BG_PLAYERYADD * 0,
		BG_PLAYERW, BG_PLAYERH,
		bGplayer1, 0, 0, "Player 1", NULL, NULL }, //* Player 1
	{ BG_PLAYERX, BG_PLAYERY + BG_PLAYERYADD * 1,
		BG_PLAYERW, BG_PLAYERH,
		bGplayer2, 0, 0, "Player 2", NULL, NULL }, //* Player 1
	{ BG_PLAYERX, BG_PLAYERY + BG_PLAYERYADD * 2,
		BG_PLAYERW, BG_PLAYERH,
		bGplayer3, 0, 0, "Player 3", NULL, NULL }, //* Player 1
	{ BG_PLAYERX, BG_PLAYERY + BG_PLAYERYADD * 3,
		BG_PLAYERW, BG_PLAYERH,
		bGplayer4, 0, 0, "Player 4", NULL, NULL }, //* Player 1
	//* Chat
	{ BG_WCHATX, BG_WCHATY, BG_WCHATW, BG_WCHATH,
		bGchat, 0, 0, "Chat", NULL, NULL }, //* Player 1
};

#endif
