/*
	TXTFILE: a simple error managment library
	Copyright (C) 2003 Antti Partanen

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Library General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Library General Public License for more details.

	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	By Antti Partanen
	(alias Duge, duge@mbnet.fi, IRCnet channel #teinidexi)
*/

#ifndef FILE_H
#define FILE_H

#include <cstdarg>

#define TXTFILE_ON 1
#define TXTFILE_OFF 0
#define TXTFILE_ONOFF TXTFILE_ON

#define TXTFILE_NONE 0
#define TXTFILE_INFO 1
#define TXTFILE_VERBOSE 2
#define TXTFILE_EXTRA 3
#define TXTFILE_EXTRADEBUG 4

//* For DLL function exporting in windows...
#if defined(WIN32) || defined(_WIN32)
#define TXTFILEEXP __declspec(dllexport)
#else
#define TXTFILEEXP
#endif

void TXTFILEEXP FILE_Open(char *file_name = "Debug.txt",
	bool console = false,
	bool file = true,
	bool msgbox = false);

void TXTFILEEXP FILE_Close();

void TXTFILEEXP FILE_SetFlags(bool console, bool file, bool msgbox);

void TXTFILEEXP FILE_Flush(void);

void TXTFILEEXP FILE_Text(int level, char *text, ...);
void TXTFILEEXP FILE_Text(int level, bool msgbox, bool console,
	bool file, char *text, ...);
void TXTFILEEXP FILE_TextI(char *text, ...);
void TXTFILEEXP FILE_TextV(char *text, ...);
void TXTFILEEXP FILE_TextE(char *text, ...);
void TXTFILEEXP FILE_TextD(char *text, ...);

void TXTFILEEXP FILE_Level(int level);

#endif
